$('#tituloModificado').on('change', function () {
    obtenerPlanesSelect();
});
$('#modalidadModificado').on('change', function () {
    obtenerPlanesSelect();
});

$('#facultadModificado').on('change', function () {
    obtenerTitulosFacultad();
});

// El coordinador -> Al pulsar el button, procedemos a preguntar y si es ok, enviar OD
$('#enviarDecanato').click(function () {

    let callbackAccept = function () {

        let url = $('#urlEnviarOrdenacion').attr('href');

        $.ajax(
            {
                data: { enviaCoordinador: 'S' },
                url: url,
                type: 'post',
                success: function (response) {
                    location.reload()
                },
                error: function (xhr, status) {
                    console.log(xhr);
                },
            }
        );
    };

    let callbackDeny = function () {
    };

    abrirDialogoModal('modalEnviarDecanato', callbackAccept, callbackDeny);

});

$('#rechazaCalidad').click(function () {
    rechazarOD();
});


// El coordinador -> Al pulsar el button, procedemos a preguntar el motivo para rechazar el OD
$('#rechazaOD').click(function () {
    rechazarOD();
});

function rechazarOD() {
    let callbackAccept = function () {

        let url = $('#urlEnviarOrdenacion').attr('href');
        let motivo = $('#textoRechazar').val();
        let propuesta = $('#textoPropuesta').val();
        let facultad = $("#facultadModificado").val();
        let errorForm = false;

        if (motivo.length == 0) {
            errorForm = true;
            gestionErrores($("#textoRechazar"), true);
        } else {
            gestionErrores($("#textoRechazar"), false);
        }

        if (propuesta.length == 0) {
            errorForm = true;
            gestionErrores($("#textoPropuesta"), true);
        } else {
            gestionErrores($("#textoPropuesta"), false);
        }

        //si no hay errores
        if (errorForm) {
            return false;
        } else {
            $.ajax(
                {
                    data: { rechazar: 'S', motivo: motivo, facultad: facultad, propuesta: propuesta },
                    url: url,
                    type: 'post',
                    success: function (response) {
                        location.reload()
                    },
                    error: function (xhr, status) {
                        console.log(xhr);
                    },
                }
            );
        }
    };

    let callbackDeny = function () {
    };

    abrirDialogoModal('modalRechazarDecanato', callbackAccept, callbackDeny);
}


/********************************* */
// el decanato -> a calidad rectorado
$('#enviaCalidad').click(function () {

    let callbackAccept = function () {

        let url = $('#urlEnviarOrdenacion').attr('href');

        $.ajax(
            {
                data: { enviaCalidad: 'S' },
                url: url,
                type: 'post',
                success: function (response) {
                    location.reload()
                },
                error: function (xhr, status) {
                    console.log(xhr);
                },
            }
        );
    };

    let callbackDeny = function () {
    };

    abrirDialogoModal('modalEnviarDecanato', callbackAccept, callbackDeny);

});


/********************************* */
//validar la OD
$('#validaOD').click(function () {

    let errorForm = false;
    let facultad = $('#facultadModificado').val();
    //comprobamos el texto
    if (facultad.length == 0) {
        errorForm = true;
        gestionErrores($("#facultadModificado"), true);
    } else {
        gestionErrores($("#facultadModificado"), false);
    }

    //si no hay errores
    if (errorForm) {
        return false;
    } else {
        let callbackAccept = function () {

            let url = $('#urlEnviarOrdenacion').attr('href');

            $.ajax(
                {
                    data: { enviaRector: 'S', facultad: facultad },
                    url: url,
                    type: 'post',
                    success: function (response) {
                        location.reload()
                    },
                    error: function (xhr, status) {
                        console.log(xhr);
                    },
                }
            );
        };

        let callbackDeny = function () {
        };

        abrirDialogoModal('modalEnviarDecanato', callbackAccept, callbackDeny);
    }

});

function obtenerPlanesSelect() {

    let url = $('#urlObtenerPlanes').attr('href');
    let id = $('#tituloModificado').val();
    let modalidad = $('#modalidadModificado').val();

    //vaciar el select   
    $('#planModificado').empty();

    $.ajax(
        {
            data: { titulo: id, modalidad: modalidad },
            url: url,
            type: 'post',
            success: function (response) {
                //obtenemos las asignaturas de ese ti.
                let asigna = JSON.parse(response);

                // Recorrer el objeto para rellenar el select
                $.each(asigna, function (index, objeto) {
                    $('#planModificado').append($('<option>', { value: index, text: objeto }));
                });

            },
            error: function (xhr, status) {
                console.log(xhr);
            },
        }
    );

}



/******************************************************** */
function guardarDocente(idDocente, idAsignatura, recargar) {
    event.preventDefault();

    let url = $('#urlGuardarDocenteAsignatura').attr('href');
    $("#asunto").html('');
    let tipoAsignatura = $('#tipoAsignatura').val();
    let sinError = true; //no hay errores

    let creditos = parseFloat($('#creditos_' + idAsignatura).val(), 10);
    let creditosAsignados = parseFloat($('#asignados_' + idAsignatura).html(), 10);
    let creditosAsignatura = parseFloat($('#creditosAsigna_' + idAsignatura).html(), 10);

    let grupos = 1;
    let codigoAsigna = idAsignatura;

    console.info(creditos + ' -- ' + creditosAsignatura + ' // ' + creditosAsignados + ' ** ' + tipoAsignatura);

    //si tiene grupos, el formato de la asignatura es codigoasigna_grupo
    if (idAsignatura.indexOf('_') > 0) {
        let datos = idAsignatura.split('_');
        codigoAsigna = datos[0];
        grupos = datos[1];
    }

    if (tipoAsignatura == 2) {
        if (creditos < 1) {
            sinError = false;
            $("#asunto").html('El valor de los créditos introducido no es correcto');
        }
    }
    else {
        if (creditos < 1 || creditosAsignados + creditos > creditosAsignatura) {
            sinError = false;
            $("#asunto").html('El valor de los créditos introducido no es correcto');
        }
    }

    let callbackDeny = function () {
    };

    if (creditos === "" || isNaN(creditos) ){
        sinError = false;
        $("#asunto").html('El valor de los créditos introducido no es correcto');
    }

    if (sinError) {

        $.ajax(
            {
                data: { pdi: idDocente, asignatura: codigoAsigna, creditos: creditos, grupo: grupos },
                url: url,
                type: 'post',
                success: function (response) {
                    if (recargar === 'S') {
                        window.location.href = window.location.href;
                        location.reload();
                    }
                    //;
                },
                error: function (xhr, status) {
                    console.log(xhr);
                },
            }
        );

    } else {
        abrirDialogoModal('resultadoasignacion', callbackDeny, callbackDeny);
    }

}

/***********************
 * 
 */

function filtrarDatos() {
    event.preventDefault();

    let titulo = $('#tituloModificado').val();

    if (titulo.length == 0) {
        errorForm = true;
        gestionErrores($("#tituloModificado"), true);
    } else {
        gestionErrores($("#tituloModificado"), false);
    }

    if (titulo) {
        $('#formBuscaDocente').submit();
    } else {
        return false;
    }

}

/***********************
 * 
 */
//al desplegar los datos  por DA y D, hay que recalcular los % para mostrarlos por lote DA+D sin tener LIC en cuenta
function mostrarDatosRatio(startingId) {
    event.preventDefault();
    let clase = " ui red label "; //para indicar que no se cumple
    let minDA = $('#minPorDA').val(); //en caso de ser menor que minDa avisar

    //aplicamos cambios en los porcentajes, ya que se muestran los generales y quiere los particulares
    let porcentajeDoctorAcreditado = $('#porcentaje_' + startingId + '_DA').html();
    let porcentajeDoctor = $('#porcentaje_' + startingId + '_D').html();
    //pasamos a float o 0 en caso contrario, para que no de NAN
    let porDoctorAcreditado = parseFloat(porcentajeDoctorAcreditado) || 0;
    let porDoctor = parseFloat(porcentajeDoctor) || 0;
    //nuevo total
    let total = porDoctorAcreditado + porDoctor;
    //calcular porcentajes
    let pDa = porDoctorAcreditado * 100 / total;
    let pD = porDoctor * 100 / total;

    console.log(porDoctorAcreditado);
    console.log(porDoctor);
    console.log(total);

    //comprobamos que sea correcto
    if (pDa < minDA) {
        console.log(pDa+' ES MENOR '+ minDA);
        $('#div_' + startingId + '_DA').addClass(clase);
    }

    //mostramos los nuevos datos
    $('#porcentaje_' + startingId + '_DA').html(pDa.toFixed(2));
    $('#porcentaje_' + startingId + '_D').html(pD.toFixed(2));

    //ocultar o mostrar las filas con los doctores 
    $("[id^='" + startingId + "']").toggle();

}

/***********************
 * Rellena la asignatua indicada con todos los cre.
 */

function rellenarCreditos(id) {
    let creditos = $('#creditosAsigna_' + id).html();
    if ($('#cb_' + id).prop('checked')) {
        $("#creditos_" + id).val(creditos);
    } else {
        $("#creditos_" + id).val(0);
    }
    return true;
}

/***************************
 * Guarda todas asignaturas marcadas por el usuario a un docente
 */
function guardarTodosDocente(idDocente) {

    let url = $('#urlGuardarDocenteAsignatura').attr('href');
    let cadenaAsignaturas = '';
    // Recorrer todos los valores del array checkboxStates para obtener las asignaturas con sus grupos
    for (var key in checkboxStates) {
        if (checkboxStates.hasOwnProperty(key)) {
            var value = checkboxStates[key];
            if (value) {
                cadenaAsignaturas = cadenaAsignaturas + key + '@@';
            }
        }
    }

    console.info(cadenaAsignaturas);
    if (cadenaAsignaturas.length > 0) {
        $.ajax(
            {
                data: { pdi: idDocente, asignatura: cadenaAsignaturas },
                url: url,
                type: 'post',
                success: function (response) {
                    window.location.href = window.location.href;
                    location.reload();
                },
                error: function (xhr, status) {
                    console.log(xhr);
                },
            }
        );
    }

    return true;

}

/********************************
 * para marcar varias asignaturas 
 */
$('input[type="checkbox"]').on('change', function () {
    let key = $(this).attr('id').replace("cb_", "");
    checkboxStates[key] = $(this).is(':checked');
    if ($(this).is(':checked')) {
        $('#creditos_' + key).prop('readonly', true);
    } else {
        $('#creditos_' + key).prop('readonly', false);
    }

});

/***********************************************************************************************************/

function borrarasignatura_pdi(id) {

    event.preventDefault();
    console.log('Borrar');

    let nombre = $("#nombre_" + id).html();

    $("#asuntoEliminar").html('Va a eliminar: ' + nombre + ' ¿Es correcto?');

    let callbackAccept = function () {
        let url = $('#urlEliminarasignatura_pdi').attr('href');
        realizarAjax({ id: id }, url, location.reload(), null);
    };

    let callbackDeny = function () {
    };

    abrirDialogoModal('eliminarasignatura_pdi', callbackAccept, callbackDeny);
}


/***********************************************************************************************************/

function reemplazar_pdi(anterior) {

    event.preventDefault();
    console.log('REEMPLAZAR');
    let nombre = $("#nombre_" + anterior).html();
    let titulo = $("#tituloModalInicio").val();

    $("#tituloModal").html(titulo + ': ' + nombre);

    let callbackAccept = function () {
        let url = $('#urlCambiarPdi').attr('href');
        let nuevo = $('.ui.search.selection.dropdown').dropdown('get value');
        let errorForm = false;

        //en caso de no seleccionar o seleccionar el mismo docente
        if (nuevo === '' || anterior == nuevo) {
            errorForm = true;
            gestionErrores($("#labelDocenteReemplaza"), true);
        } else {
            gestionErrores($("#labelDocenteReemplaza"), false);
        }

        //si no hay errores
        if (errorForm) {

            return false;
        } else {

            realizarAjax({ anterior: anterior, nuevo: nuevo }, url, location.reload(), null);
        }

    };

    let callbackDeny = function () {

    };

    abrirDialogoModal('sustituirpdi', callbackAccept, callbackDeny);
}


