// Estructura de datos para almacenar los estados de los checkboxes al realizar un nuevo préstamo
var checkboxStates = {};

$(document).ready(function () {

    var elemento = $('#nombreUsuarioApp');
    var valorElemento = elemento.text().trim();  // Obtener el texto del elemento y eliminar espacios en blanco

    // Verificar si el valor del elemento contiene la palabra "anie"
    if (valorElemento.includes('anie')) {
        // Llamar a la función para simular la lluvia
        simularLluvia();
    }

    //todos los volver regresan a la page anterior
    $('a[title="Volver"]').attr('href', 'javascript:history.back()');

    $('#pusher').on('click', function () {
        // Cerrar el menú al hacer clic en un elemento
        $('.ui.sidebar').sidebar('toggle');
    });

    //$("table tr:odd").css("background-color", "lightgray");

    $('.tabular.menu .item').tab();

    $('.datepicker').datepicker({

    });

    $('.ui.accordion').accordion();

    new DataTable('#datosTabla', {
        layout: {
            top: {
                buttons: ['excel', 'copy']
            }
        },
        lengthMenu: [[10, 25, 50, -1], [10, 25, 50, "All"]], // Define the length menu options

        language: {
            url: '//cdn.datatables.net/plug-ins/1.10.16/i18n/Spanish.json'
        },
    });

    new DataTable('#datosTablaDos', {
        layout: {
            top: {
                buttons: ['excel', 'copy']
            }
        },
        autoWidth: true,
        language: {
            url: '//cdn.datatables.net/plug-ins/1.10.16/i18n/Spanish.json'
        },
    });

    new DataTable('#datosTablaTres', {
        layout: {
            top: {
                buttons: ['excel', 'copy']
            }
        },
        autoWidth: true,
        language: {
            url: '//cdn.datatables.net/plug-ins/1.10.16/i18n/Spanish.json'
        },
    });

    /* $("#datosTablaTres").DataTable({
         language: {
             url: '//cdn.datatables.net/plug-ins/1.10.16/i18n/Spanish.json'
         },                
         "ordering": true,
         "drawCallback": function () {        
             $('.opcionesMenu').popup({
                 lastResort: 'left center',
                 position: 'left center',
                 hoverable: true,
                 distanceAway: 1,
                 delay: {
                     show: 300,
                     hide: 800
                 },
                 transition: 'slide down',
             });
         }
     });*/

    /* $("#datosTabla").DataTable({
         language: {
             url: '//cdn.datatables.net/plug-ins/1.10.16/i18n/Spanish.json'
         },        
         "ordering": true,
         "drawCallback": function () {           
             $('.opcionesMenu').popup({
                 lastResort: 'left center',
                 position: 'left center',
                 hoverable: true,
                 distanceAway: 1,
                 delay: {
                     show: 300,
                     hide: 800
                 },
                 transition: 'slide down',
             });
         }
     });*/


    $('.ui.dropdown').dropdown();

    $("input:text").click(function () {
        $(this).parent().find("input:file").click();
    });

    $('input:file', '.ui.action.input')
        .on('change', function (e) {
            var name = e.target.files[0].name;
            $('input:text', $(e.target).parent()).val(name);
        });

});


/** Abre un modal **/
function abrirDialogoModal(claseDelModal, callbackAccept, callbackDeny) {

    callbackDeny = typeof callbackDeny === 'undefined' ? function () {
        $("." + claseDelModal).modal('hide');
        return false;
    } : callbackDeny;


    callbackAccept = typeof callbackAccept === 'undefined' ? function () {
    } : callbackAccept;


    $("." + claseDelModal).modal({
        closable: false,
        transition: 'fade up',
        onApprove: callbackAccept,
        onDeny: callbackDeny,
        onShow: function () {
            $(this).draggable({
            });
        }
    }).modal('show');
}


// Función para calcular el hash MD5
function md5(str) {
    /*  var hash = 0;
      if (str.length === 0) {
          return hash;
      }
      for (var i = 0; i < str.length; i++) {
          var char = str.charCodeAt(i);
          hash = (hash << 5) - hash + char;
          hash = hash & hash; // Convierte a un entero de 32 bits
      }
      return hash.toString(16);*/
    return CryptoJS.MD5(str).toString()
}

//reañiza ajax
function realizarAjax(parametros, url, funcionOk, funcionKo) {

    $.ajax(
        {
            data: parametros,
            url: url,
            type: 'post',
            success: function (response) {
                funcionOk;
            },
            error: function (xhr, status) {
                funcionKo;
            },
        }
    );

}

//muestra recuadro de error en los formularios 
function gestionErrores(elemento, error) {

    if (error) {
        elemento.css("border", "2px solid red");
    } else {
        elemento.css("border", "1px solid #E7E5E5");
    }

}

//valida un mail
function isEmail(email) {
    var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
    return regex.test(email);
}


function obtenerTitulosFacultad() {

    let url = $('#urlObternerTitulosFacultad').attr('href');
    let id = $('#facultadModificado').val();

    //vaciar el select   
    $('#tituloModificado').empty();
    console.info(url);
    $.ajax(
        {
            data: { facultad: id },
            url: url,
            type: 'post',
            success: function (response) {
                //obtenemos las asignaturas de ese ti.
                let asigna = JSON.parse(response);
                $('#tituloModificado').append($('<option>', { value: '', text: 'Seleccionar' }));
                // Recorrer el objeto para rellenar el select
                $.each(asigna, function (index, objeto) {
                    $('#tituloModificado').append($('<option>', { value: index, text: objeto }));
                });

            },
            error: function (xhr, status) {
                console.log(xhr);
            },
        }
    );

}
/**********************************************************************************************************/
/**********************************************************************************************************/
/**********************************************************************************************************/

function simularLluvia() {

    // Crear el cuerpo de la mosca
    var mosca = $('<div></div>').css({
        'position': 'absolute',
        'width': '20px',
        'height': '20px',
        'background-color': 'black',
        'border-radius': '50%',
        'pointer-events': 'none' // Para que la mosca no interfiera con los eventos del ratón
    });

    // Crear las alas de la mosca
    var alaIzquierda = $('<div></div>').css({
        'position': 'absolute',
        'width': '15px',
        'height': '15px',
        'background-color': 'rgba(0, 0, 0, 0.5)',
        'border-radius': '50%',
        'top': '-10px',
        'left': '-10px'
    });

    var alaDerecha = $('<div></div>').css({
        'position': 'absolute',
        'width': '15px',
        'height': '15px',
        'background-color': 'rgba(0, 0, 0, 0.5)',
        'border-radius': '50%',
        'top': '-10px',
        'right': '-10px'
    });

    // Crear los ojos de la mosca
    var ojoIzquierdo = $('<div></div>').css({
        'position': 'absolute',
        'width': '5px',
        'height': '5px',
        'background-color': 'white',
        'border-radius': '50%',
        'top': '5px',
        'left': '3px'
    });

    var ojoDerecho = $('<div></div>').css({
        'position': 'absolute',
        'width': '5px',
        'height': '5px',
        'background-color': 'white',
        'border-radius': '50%',
        'top': '5px',
        'right': '3px'
    });

    // Agregar las alas y los ojos al cuerpo de la mosca
    mosca.append(alaIzquierda);
    mosca.append(alaDerecha);
    mosca.append(ojoIzquierdo);
    mosca.append(ojoDerecho);

    // Agregar la mosca al cuerpo del documento
    $('body').append(mosca);

    // Función para mover la mosca aleatoriamente
    function moverMosca() {
        var newLeft = Math.random() * ($(window).width() - 20);
        var newTop = Math.random() * ($(window).height() - 20);
        mosca.animate({
            'left': newLeft + 'px',
            'top': newTop + 'px'
        }, 1000, function () {
            moverMosca();
        });
    }

    // Iniciar el movimiento aleatorio de la mosca
    moverMosca();

    // Manejar el evento de movimiento del ratón
    $(document).mousemove(function(event) {
        var mouseX = event.pageX;
        var mouseY = event.pageY;
        var moscaX = mosca.offset().left;
        var moscaY = mosca.offset().top;
        var moscaWidth = mosca.width();
        var moscaHeight = mosca.height();

        // Calcular la distancia entre el ratón y la mosca
        var distancia = Math.sqrt(Math.pow(mouseX - (moscaX + moscaWidth / 2), 2) + Math.pow(mouseY - (moscaY + moscaHeight / 2), 2));

        // Verificar si el ratón está cerca de la mosca (por ejemplo, dentro de 50 píxeles)
        if (distancia < 50) {
            mosca.stop().fadeOut(500, function() {
                $(this).remove();
            });
        }
    });



}