<?php

namespace App\Entity\GP;

use Doctrine\ORM\Mapping as ORM;

/**
 * TPersonal
 *
 * @ORM\Table(name="unam_gp.personal_t", schema="unam_gp")
 * @ORM\Entity
 */
class TPersonal
{
    const K_GENERO = ['M' => "Masculino", 'F' => "Femenino", 'O' => 'Otros'];
    const K_ENTIDAD = 'App\Entity\GP\TPersonal';
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="unam_gp.personal_t_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="nombre", type="string", nullable=false)
     */
    private $nombre;

    /**
     * @var string
     *
     * @ORM\Column(name="apellido1", type="string", nullable=false)
     */
    private $apellido1;

    /**
     * @var string
     *
     * @ORM\Column(name="apellido2", type="string", nullable=false)
     */
    private $apellido2;

    /**
     * @var string
     *
     * @ORM\Column(name="dni", type="string", nullable=false)
     */
    private $dni;

    /**
     * @var string
     *
     * @ORM\Column(name="genero", type="string", nullable=false)
     */
    private $genero;

    /**
     * @var string
     *
     * @ORM\Column(name="titulo", type="string", nullable=false)
     */
    private $titulo;

    /**
     * @var string
     *
     * @ORM\Column(name="mail_personal", type="string", nullable=false)
     */
    private $mailPersonal;

    /**
     * @var string
     *
     * @ORM\Column(name="mail_unam", type="string", nullable=false)
     */
    private $mailUnam;

    /**
     * @var string
     *
     * @ORM\Column(name="telefono", type="string", nullable=false)
     */
    private $telefono;

    //array con los contratos del personal
    private $contrato;



    /**
     * Get the value of id
     *
     * @return  int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set the value of id
     *
     * @param  int  $id
     *
     * @return  self
     */
    public function setId(int $id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * Get the value of nombre
     *
     * @return  string
     */
    public function getNombre()
    {
        return $this->nombre;
    }

    /**
     * Set the value of nombre
     *
     * @param  string  $nombre
     *
     * @return  self
     */
    public function setNombre(string $nombre)
    {
        $this->nombre = $nombre;

        return $this;
    }

    /**
     * Get the value of apellido1
     *
     * @return  string
     */
    public function getApellido1()
    {
        return $this->apellido1;
    }

    /**
     * Set the value of apellido1
     *
     * @param  string  $apellido1
     *
     * @return  self
     */
    public function setApellido1(string $apellido1)
    {
        $this->apellido1 = $apellido1;

        return $this;
    }

    /**
     * Get the value of apellido2
     *
     * @return  string
     */
    public function getApellido2()
    {
        return $this->apellido2;
    }

    /**
     * Set the value of apellido2
     *
     * @param  string  $apellido2
     *
     * @return  self
     */
    public function setApellido2(string $apellido2)
    {
        $this->apellido2 = $apellido2;

        return $this;
    }

    /**
     * Get the value of dni
     *
     * @return  string
     */
    public function getDni()
    {
        return $this->dni;
    }

    /**
     * Set the value of dni
     *
     * @param  string  $dni
     *
     * @return  self
     */
    public function setDni(string $dni)
    {
        $this->dni = $dni;

        return $this;
    }

    /**
     * Get the value of genero
     *
     * @return  string
     */
    public function getGenero()
    {
        return $this->genero;
    }

    /**
     * Set the value of genero
     *
     * @param  string  $genero
     *
     * @return  self
     */
    public function setGenero(string $genero)
    {
        $this->genero = $genero;

        return $this;
    }

    /**
     * Get the value of titulo
     *
     * @return  string
     */
    public function getTitulo()
    {
        return $this->titulo;
    }

    /**
     * Set the value of titulo
     *
     * @param  string  $titulo
     *
     * @return  self
     */
    public function setTitulo(string $titulo)
    {
        $this->titulo = $titulo;

        return $this;
    }

    /**
     * Get the value of mailPersonal
     *
     * @return  string
     */
    public function getMailPersonal()
    {
        return $this->mailPersonal;
    }

    /**
     * Set the value of mailPersonal
     *
     * @param  string  $mailPersonal
     *
     * @return  self
     */
    public function setMailPersonal(string $mailPersonal)
    {
        $this->mailPersonal = $mailPersonal;

        return $this;
    }

    /**
     * Get the value of mailUnam
     *
     * @return  string
     */
    public function getMailUnam()
    {
        return $this->mailUnam;
    }

    /**
     * Set the value of mailUnam
     *
     * @param  string  $mailUnam
     *
     * @return  self
     */
    public function setMailUnam(string $mailUnam)
    {
        $this->mailUnam = $mailUnam;

        return $this;
    }

    /**
     * Get the value of telefono
     *
     * @return  string
     */
    public function getTelefono()
    {
        return $this->telefono;
    }

    /**
     * Set the value of telefono
     *
     * @param  string  $telefono
     *
     * @return  self
     */
    public function setTelefono(string $telefono)
    {
        $this->telefono = $telefono;

        return $this;
    }

    /**
     * Get the value of contrato
     */ 
    public function getContrato()
    {
        return $this->contrato;
    }

    /**
     * Set the value of contrato
     *
     * @return  self
     */ 
    public function setContrato($contrato)
    {
        $this->contrato = $contrato;

        return $this;
    }
}
