<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * TAsignatura
 *
 * @ORM\Table(name="asignatura_t", schema="unam_ga")
 * @ORM\Entity
 */
class TAsignatura
{
    const K_ENTIDAD = 'App\Entity\TAsignatura';
    const K_TIPOS = ['' => '', 'OB' => 'Obligatoria', 'FB' => 'Formación básica', 'OP' => 'Optativa', 'PAE' => 'Prácticas externas', 'TFG' => 'Trabajo fin de grado', 'TFM' => 'Trabajo fin de máster'];
    const K_TIPOS_ASIGNA = [1 => 'Asignaturas', 2 => 'TFT y PAE'];
    const K_DIDACTICA = '(Práctica)';
    const K_TEORIA = '(Teoría)';
    const K_COD_DIDACTICA = 'P';
    const K_TFT_PAE = 2;
    const K_TIPO_NORMAL = 1;
    const K_DUAL = 'DUAL';
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="unam_ga.asignatura_t_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;

    /**
     * @var int
     *
     * @ORM\Column(name="creditos", type="decimal", nullable=false)
     */
    private $creditos;

    /**
     * @var int
     *
     * @ORM\Column(name="creditosalumno", type="decimal", nullable=false)
     */
    private $creditosAlumno;

    /**
     * @var int
     *
     * @ORM\Column(name="horas", type="decimal", nullable=false)
     */
    private $horas;

    /**
     * @var \TTitulacionMaestro
     *
     * @ORM\ManyToOne(targetEntity="TTitulacionMaestro")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="titulacion_id", referencedColumnName="id")
     * })
     */
    private $titulacion;


    /**
     * @var \TTitulacion
     *
     * @ORM\ManyToOne(targetEntity="TTitulacion")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="titulo_plan_modalidad_id", referencedColumnName="id")
     * })
     */
    private $titulo_plan_modalidad;


    /**
     * @var string
     *
     * @ORM\Column(name="tipo", type="string", nullable=false)
     */
    private $tipo;

    /**
     * @var string
     *
     * @ORM\Column(name="didactica", type="string", nullable=false)
     */
    private $didactica;

    /**
     * @var int
     *
     * @ORM\Column(name="tipo_asignatura", type="integer", nullable=false)
     */
    private $tipoAsignatura;

    /**
     * @var \TPlan
     *
     * @ORM\ManyToOne(targetEntity="TPlan")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="plan_id", referencedColumnName="id")
     * })
     */
    private $plan;

    /**
     * @var \TAsignaturaMaestro
     *
     * @ORM\ManyToOne(targetEntity="TAsignaturaMaestro")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="asignaturamaestro_id", referencedColumnName="id")
     * })
     */
    private $asignatura;

    /**
     * @var \TModalidad
     *
     * @ORM\ManyToOne(targetEntity="TModalidad")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="modalidad_id", referencedColumnName="id")
     * })
     */
    private $modalidad;

    /**
     * @var \App\Entity\TDepartamento
     *
     * @ORM\ManyToOne(targetEntity="TDepartamento")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="departamento_id", referencedColumnName="id")
     * })
     */
    private $dpto;

    /**
     * Get the value of id
     *
     * @return  int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set the value of id
     *
     * @param  int  $id
     *
     * @return  self
     */
    public function setId(int $id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * Get the value of creditos
     *
     * @return  int
     */
    public function getCreditos()
    {
        return $this->creditos;
    }

    /**
     * Set the value of creditos
     *
     * @param  int  $creditos
     *
     * @return  self
     */
    public function setCreditos($creditos)
    {
        $this->creditos = $creditos;

        return $this;
    }

    /**
     * Get the value of horas
     *
     * @return  int
     */
    public function getHoras()
    {
        return $this->horas;
    }

    /**
     * Set the value of horas
     *
     * @param  int  $horas
     *
     * @return  self
     */
    public function setHoras($horas)
    {
        $this->horas = $horas;

        return $this;
    }


    /**
     * Get the value of titulacion
     *
     * @return  \TTitulacion
     */
    public function getTitulacion()
    {
        return $this->titulacion;
    }

    /**
     * Set the value of titulacion
     *
     * @param  \TTitulacion  $titulacion
     *
     * @return  self
     */
    public function setTitulacion($titulacion)
    {
        $this->titulacion = $titulacion;

        return $this;
    }

    /**
     * Get the value of tipo
     *
     * @return  string
     */
    public function getTipo()
    {
        return $this->tipo;
    }

    /**
     * Set the value of tipo
     *
     * @param  string  $tipo
     *
     * @return  self
     */
    public function setTipo(string $tipo)
    {
        $this->tipo = $tipo;

        return $this;
    }

    /**
     * Get the value of plan
     *
     * @return  \TPlan
     */
    public function getPlan()
    {
        return $this->plan;
    }

    /**
     * Set the value of plan
     *
     * @param  \TPlan  $plan
     *
     * @return  self
     */
    public function setPlan($plan)
    {
        $this->plan = $plan;

        return $this;
    }

    /**
     * Get the value of asignatura
     *
     * @return  \TAsignaturaMaestro
     */
    public function getAsignatura()
    {
        return $this->asignatura;
    }

    /**
     * Set the value of asignatura
     *
     * @param  \TAsignaturaMaestro  $asignatura
     *
     * @return  self
     */
    public function setAsignatura($asignatura)
    {
        $this->asignatura = $asignatura;

        return $this;
    }

    /**
     * Get the value of creditosAlumno
     *
     * @return  int
     */
    public function getCreditosAlumno()
    {
        return $this->creditosAlumno;
    }

    /**
     * Set the value of creditosAlumno
     *
     * @param  int  $creditosAlumno
     *
     * @return  self
     */
    public function setCreditosAlumno($creditosAlumno)
    {
        $this->creditosAlumno = $creditosAlumno;

        return $this;
    }

    /**
     * Get the value of modalidad
     *
     * @return  \TModalidad
     */
    public function getModalidad()
    {
        return $this->modalidad;
    }

    /**
     * Set the value of modalidad
     *
     * @param  \TModalidad  $modalidad
     *
     * @return  self
     */
    public function setModalidad($modalidad)
    {
        $this->modalidad = $modalidad;

        return $this;
    }

    /**
     * Get the value of titulo_plan_modalidad
     *
     * @return  \TTitulacion
     */
    public function getTitulo_plan_modalidad()
    {
        return $this->titulo_plan_modalidad;
    }

    /**
     * Set the value of titulo_plan_modalidad
     *
     * @param  \TTitulacion  $titulo_plan_modalidad
     *
     * @return  self
     */
    public function setTitulo_plan_modalidad($titulo_plan_modalidad)
    {
        $this->titulo_plan_modalidad = $titulo_plan_modalidad;

        return $this;
    }

    /**
     * Get the value of tipoAsignatura
     *
     * @return  int
     */
    public function getTipoAsignatura()
    {
        return $this->tipoAsignatura;
    }

    /**
     * Set the value of tipoAsignatura
     *
     * @param  int  $tipoAsignatura
     *
     * @return  self
     */
    public function setTipoAsignatura($tipoAsignatura)
    {
        $this->tipoAsignatura = $tipoAsignatura;

        return $this;
    }

    /**
     * Get the value of dpto
     *
     * @return  \App\Entity\TDepartamento
     */
    public function getDpto()
    {
        return $this->dpto;
    }

    /**
     * Set the value of dpto
     *
     * @param  \App\Entity\TDepartamento  $dpto
     *
     * @return  self
     */
    public function setDpto($dpto)
    {
        $this->dpto = $dpto;

        return $this;
    }

    /**
     * Get the value of didactica
     *
     * @return  string
     */ 
    public function getDidactica()
    {
        return $this->didactica;
    }

    /**
     * Set the value of didactica
     *
     * @param  string  $didactica
     *
     * @return  self
     */ 
    public function setDidactica($didactica)
    {
        $this->didactica = $didactica;

        return $this;
    }
}
