<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * TAsignaturaCurso
 *
 * @ORM\Table(name="asignatura_curso_t" , schema="unam_ga")
 * @ORM\Entity
 */
class TAsignaturaCurso
{

    const K_ENTIDAD = 'App\Entity\TAsignaturaCurso';

    const K_GRUPOS = [1 => '1', 2 => '2', 3 => '3', 4 => '4', 5 => '5'];

    const K_CURSOS = [1 => 'Primero', 2 => 'Segundo', 3 => 'Tercero', 4 => 'Cuarto', 5 => 'Quinto', 6 => 'Sexto'];

    const K_SEMESTRE = [1 => 'Primer semestre', 2 => 'Segundo semestre', 3 => 'Anual', 4 => 'No aplica'];

    const K_COLORES = [1 => 'red', 2 => 'blue', 3 => 'black'];
    
    const ABECEDARIO =   [
        1 => 'A', 2 => 'B', 3 => 'C', 4 => 'D', 5 => 'E', 6 => 'F', 7 => 'G', 8 => 'H', 9 => 'I', 10 => 'J',
        11 => 'K', 12 => 'L', 13 => 'M', 14 => 'N', 15 => 'O', 16 => 'P', 17 => 'Q', 18 => 'R', 19 => 'S', 20 => 'T',
        21 => 'U', 22 => 'V', 23 => 'W', 24 => 'X', 25 => 'Y', 26 => 'Z'
    ];
    const TITULO_DUAL = 43; // aignaturas especiales // OJO DATO DE LA BD
    const FACULTAD_CCSS = 19; // aignaturas especiales // OJO DATO DE LA BD

    const K_CREDITOS_DOCTOR = 48; // para los doctores alertar si menos de 48
    const K_CREDITOS_NO_DOCTOR = 60; // Para los licenciados, alerta si menos de 60

    const K_MAX_DOCENTE_TP = 40; //Total de % de docentes en TP
    const K_MIN_D_DA = 50 ; // Al asignar, la suma debe ser por lo menos 50
    const K_MIN_DA = 60 ; // DA >= 60

    const K_JORNADA_COMPLETA = 'TC';
    const K_LICENCIADO = 'Nivel-V'; // el resto son doctores

    const K_NIVEL_PDI = [
        'Nivel-V' => 'Titulado Universitario No Doctor',
        'Nivel-III-Sub-1' => 'Contratado Doctor',
        'Nivel-III-Sub-2' => 'Ayudante Doctor',
        'Nivel-IV' => 'Doctor No Acreditado'
    ];

    //horas dedicadas por el pdi por cada alumno
    const K_HORAS_ALUMNO_PAE = 5;
    const K_HORAS_ALUMNO_TFT = 8;

    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="unam_ga.asignatura_curso_t_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;

    /**
     * @var int
     *
     * @ORM\Column(name="grupos", type="integer", nullable=false)
     */
    private $grupos;

    /**
     * @var \TAsignatura
     *
     * @ORM\ManyToOne(targetEntity="TAsignatura")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="asignatura_id", referencedColumnName="id")
     * })
     */
    private $asignatura;

    /**
     * @var \TCurso
     *
     * @ORM\ManyToOne(targetEntity="TCurso")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="curso_id", referencedColumnName="id")
     * })
     */
    private $cursoAcada;

    /**
     * @var int
     *
     * @ORM\Column(name="semestre", type="integer", nullable=false)
     */
    private $semestre;

    /**
     * @var int
     *
     * @ORM\Column(name="curso", type="integer", nullable=false)
     */
    private $curso;

    private $esDual;


    /**
     * Get the value of id
     *
     * @return  int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set the value of id
     *
     * @param  int  $id
     *
     * @return  self
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * Get the value of grupos
     *
     * @return  int
     */
    public function getGrupos()
    {
        return $this->grupos;
    }

    /**
     * Set the value of grupos
     *
     * @param  int  $grupos
     *
     * @return  self
     */
    public function setGrupos($grupos)
    {
        $this->grupos = $grupos;

        return $this;
    }

    /**
     * Get the value of asignatura
     *
     * @return  \TAsignatura
     */
    public function getAsignatura()
    {
        return $this->asignatura;
    }

    /**
     * Set the value of asignatura
     *
     * @param  \TAsignatura  $asignatura
     *
     * @return  self
     */
    public function setAsignatura($asignatura)
    {
        $this->asignatura = $asignatura;

        return $this;
    }


    /**
     * Get the value of cursoAcada
     *
     * @return  \TCurso
     */
    public function getCursoAcada()
    {
        return $this->cursoAcada;
    }

    /**
     * Set the value of cursoAcada
     *
     * @param  \TCurso  $cursoAcada
     *
     * @return  self
     */
    public function setCursoAcada($cursoAcada)
    {
        $this->cursoAcada = $cursoAcada;

        return $this;
    }

    /**
     * Get the value of semestre
     *
     * @return  int
     */
    public function getSemestre()
    {
        return $this->semestre;
    }

    /**
     * Set the value of semestre
     *
     * @param  int  $semestre
     *
     * @return  self
     */
    public function setSemestre($semestre)
    {
        $this->semestre = $semestre;

        return $this;
    }

    /**
     * Get the value of curso
     *
     * @return  int
     */
    public function getCurso()
    {
        return $this->curso;
    }

    /**
     * Set the value of curso
     *
     * @param  int  $curso
     *
     * @return  self
     */
    public function setCurso($curso)
    {
        $this->curso = $curso;

        return $this;
    }

    /**
     * Get the value of esDual
     */
    public function getEsDual()
    {
        return $this->esDual;
    }

    /**
     * Set the value of esDual
     *
     * @return  self
     */
    public function setEsDual($esDual)
    {
        $this->esDual = $esDual;

        return $this;
    }
}
