<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * TAsignaturaDual
 *
 * @ORM\Table(name="asignatura_dual_t", schema="unam_ga")
 * @ORM\Entity
 */
class TAsignaturaDual
{
    const K_ENTIDAD = 'App\Entity\TAsignaturaDual';

    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="unam_ga.asignatura_pdi_t_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;


    /**
     * @var \TAsignaturaCurso
     *
     * @ORM\ManyToOne(targetEntity="TAsignaturaCurso")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="asignatura_id", referencedColumnName="id")
     * })
     */
    private $asignatura;

    /**
     * @var \TAsignaturaCurso
     *
     * @ORM\ManyToOne(targetEntity="TAsignaturaCurso")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="asignatura_dual", referencedColumnName="id")
     * })
     */
    private $asignaturaDual;

    /**
     * Get the value of id
     *
     * @return  int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set the value of id
     *
     * @param  int  $id
     *
     * @return  self
     */
    public function setId(int $id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * Get the value of asignatura
     *
     * @return  \TAsignaturaCurso
     */
    public function getAsignatura()
    {
        return $this->asignatura;
    }

    /**
     * Set the value of asignatura
     *
     * @param  \TAsignaturaCurso  $asignatura
     *
     * @return  self
     */
    public function setAsignatura($asignatura)
    {
        $this->asignatura = $asignatura;

        return $this;
    }

    /**
     * Get the value of asignaturaDual
     *
     * @return  \TAsignaturaCurso
     */
    public function getAsignaturaDual()
    {
        return $this->asignaturaDual;
    }

    /**
     * Set the value of asignaturaDual
     *
     * @param  \TAsignaturaCurso  $asignaturaDual
     *
     * @return  self
     */
    public function setAsignaturaDual($asignaturaDual)
    {
        $this->asignaturaDual = $asignaturaDual;

        return $this;
    }
 
}
