<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * TAsignaturaPdi
 *
 * @ORM\Table(name="asignatura_pdi_t", schema="unam_ga")
 * @ORM\Entity
 */
class TAsignaturaPdi
{
    const K_ENTIDAD = 'App\Entity\TAsignaturaPdi';

    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="unam_ga.asignatura_pdi_t_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;


    /**
     * @var \TAsignaturaCurso
     *
     * @ORM\ManyToOne(targetEntity="TAsignaturaCurso")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="asignatura_id", referencedColumnName="id")
     * })
     */
    private $asignatura;


    /**
     * @var \TPersonalalta
     *
     * @ORM\ManyToOne(targetEntity="App\Entity\GP\TPersonalalta")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="docente_id", referencedColumnName="id")
     * })
     */
    private $pdi;

    /**
     * @var int
     *
     * @ORM\Column(name="creditos", type="decimal", nullable=false)
     */
    private $creditos;


    /**
     * @var int
     *
     * @ORM\Column(name="grupo", type="integer", nullable=false)
     */
    private $grupo;

    /**
     * @var \TCurso
     *
     * @ORM\ManyToOne(targetEntity="TCurso")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="curso_id", referencedColumnName="id")
     * })
     */
    private $cursoAcada;



    /**
     * Get the value of id
     *
     * @return  int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set the value of id
     *
     * @param  int  $id
     *
     * @return  self
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * Get the value of asignatura
     *
     * @return  \TAsignaturaCurso
     */
    public function getAsignatura()
    {
        return $this->asignatura;
    }

    /**
     * Set the value of asignatura
     *
     * @param  \TAsignaturaCurso  $asignatura
     *
     * @return  self
     */
    public function setAsignatura($asignatura)
    {
        $this->asignatura = $asignatura;

        return $this;
    }

    /**
     * Get the value of pdi
     *
     * @return  \TPersonalalta
     */
    public function getPdi()
    {
        return $this->pdi;
    }

    /**
     * Set the value of pdi
     *
     * @param  \TPersonalalta  $pdi
     *
     * @return  self
     */
    public function setPdi($pdi)
    {
        $this->pdi = $pdi;

        return $this;
    }

    /**
     * Get the value of creditos
     *
     * @return  int
     */
    public function getCreditos()
    {
        return $this->creditos;
    }

    /**
     * Set the value of creditos
     *
     * @param  int  $creditos
     *
     * @return  self
     */
    public function setCreditos($creditos)
    {
        $this->creditos = $creditos;

        return $this;
    }

    /**
     * Get the value of grupo
     *
     * @return  int
     */
    public function getGrupo()
    {
        return $this->grupo;
    }

    /**
     * Set the value of grupo
     *
     * @param  int  $grupo
     *
     * @return  self
     */
    public function setGrupo($grupo)
    {
        $this->grupo = $grupo;

        return $this;
    }

    /**
     * Get the value of cursoAcada
     *
     * @return  \TCurso
     */
    public function getCursoAcada()
    {
        return $this->cursoAcada;
    }

    /**
     * Set the value of cursoAcada
     *
     * @param  \TCurso  $cursoAcada
     *
     * @return  self
     */
    public function setCursoAcada($cursoAcada)
    {
        $this->cursoAcada = $cursoAcada;

        return $this;
    }   
}
