<?php

namespace App\Entity;

use App\Entity\GP\TPersonalalta;
use Doctrine\ORM\Mapping as ORM;

/**
 * TDptoPdi
 *
 * @ORM\Table(name="departamento_pdi_t", schema="unam_ga")
 * @ORM\Entity
 */
class TDptoPdi
{
    const K_ENTIDAD = 'App\Entity\TDptoPdi';
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="unam_ga.departamento_pdi_t_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;

    /**
     * @var \TDepartamento
     *
     * @ORM\ManyToOne(targetEntity="TDepartamento")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="dpto_id", referencedColumnName="id")
     * })
     */
    private $dpto;

    /**
     * @var \TPersonalalta
     *
     * @ORM\ManyToOne(targetEntity="App\Entity\GP\TPersonalalta")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="pdi_id", referencedColumnName="id")
     * })
     */
    private $pdi;

    /**
     * Get the value of id
     *
     * @return  int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set the value of id
     *
     * @param  int  $id
     *
     * @return  self
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * Get the value of dpto
     *
     * @return  \TDepartamento
     */
    public function getDpto()
    {
        return $this->dpto;
    }

    /**
     * Set the value of dpto
     *
     * @param  \TDepartamento  $dpto
     *
     * @return  self
     */
    public function setDpto($dpto)
    {
        $this->dpto = $dpto;

        return $this;
    }



    /**
     * Get the value of pdi
     *
     * @return  \TPersonalalta
     */ 
    public function getPdi()
    {
        return $this->pdi;
    }

    /**
     * Set the value of pdi
     *
     * @param  \TPersonalalta  $pdi
     *
     * @return  self
     */ 
    public function setPdi($pdi)
    {
        $this->pdi = $pdi;

        return $this;
    }
}
