<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * TLog
 *
 * @ORM\Table(name="log_t", schema="unam_inventario")
 * @ORM\Entity
 */
class TLog
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="bigint", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var \DateTime|null
     *
     * @ORM\Column(name="fecha", type="datetime", nullable=true)
     */
    private $fecha;   

     /**
     * @var int
     *
     * @ORM\Column(name="accion", type="integer", nullable=false)
     */
    private $accion;

    /**
     * @var \Tusuarios
     *
     * @ORM\ManyToOne(targetEntity="Tusuarios")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="usuario_id", referencedColumnName="id")
     * })
     */
    private $usuario;

    /**
     * @var string
     *
     * @ORM\Column(name="datos", type="string", nullable=true)
     */
    private $datos;



    /**
     * Get the value of id
     *
     * @return  int
     */ 
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set the value of id
     *
     * @param  int  $id
     *
     * @return  self
     */ 
    public function setId( $id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * Get the value of fecha
     *
     * @return  \DateTime|null
     */ 
    public function getFecha()
    {
        return $this->fecha;
    }

    /**
     * Set the value of fecha
     *
     * @param  \DateTime|null  $fecha
     *
     * @return  self
     */ 
    public function setFecha($fecha)
    {
        $this->fecha = $fecha;

        return $this;
    }

    /**
     * Get the value of accion
     *
     * @return  int
     */ 
    public function getAccion()
    {
        return $this->accion;
    }

    /**
     * Set the value of accion
     *
     * @param  int  $accion
     *
     * @return  self
     */ 
    public function setAccion( $accion)
    {
        $this->accion = $accion;

        return $this;
    }

    /**
     * Get the value of usuario
     *
     * @return  \Tusuarios
     */ 
    public function getUsuario()
    {
        return $this->usuario;
    }

    /**
     * Set the value of usuario
     *
     * @param  \Tusuarios  $usuario
     *
     * @return  self
     */ 
    public function setUsuario( $usuario)
    {
        $this->usuario = $usuario;

        return $this;
    }

    /**
     * Get the value of datos
     *
     * @return  string
     */ 
    public function getDatos()
    {
        return $this->datos;
    }

    /**
     * Set the value of datos
     *
     * @param  string  $datos
     *
     * @return  self
     */ 
    public function setDatos( $datos)
    {
        $this->datos = $datos;

        return $this;
    }
}
