<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * TTitulacion
 *
 * @ORM\Table(name="titulacion_t", schema="unam_ga")
 * @ORM\Entity
 */
class TTitulacion
{
    const K_ENTIDAD = 'App\Entity\TTitulacion';
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="unam_ga.titulacion_t_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="activo", type="decimal", precision=10, scale=0, nullable=false, options={"default"="1"})
     */
    private $activo = '1';

    /**
     * @var \TFacultad
     *
     * @ORM\ManyToOne(targetEntity="TFacultad")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="facultad_id", referencedColumnName="id")
     * })
     */
    private $facultad;

    /**
     * @var \TModalidad
     *
     * @ORM\ManyToOne(targetEntity="TModalidad")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="modalidad_id", referencedColumnName="id")
     * })
     */
    private $modalidad;

    /**
     * @var \TPlan
     *
     * @ORM\ManyToOne(targetEntity="TPlan")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="plan_id", referencedColumnName="id")
     * })
     */
    private $plan;

    /**
     * @var \TTitulacionMaestro
     *
     * @ORM\ManyToOne(targetEntity="TTitulacionMaestro")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="titulo_id", referencedColumnName="id")
     * })
     */
    private $titulo;


    /**
     * Get the value of id
     *
     * @return  int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set the value of id
     *
     * @param  int  $id
     *
     * @return  self
     */
    public function setId(int $id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * Get the value of activo
     *
     * @return  string
     */
    public function getActivo()
    {
        return $this->activo;
    }

    /**
     * Set the value of activo
     *
     * @param  string  $activo
     *
     * @return  self
     */
    public function setActivo($activo)
    {
        $this->activo = $activo;

        return $this;
    }

    /**
     * Get the value of facultad
     *
     * @return  \TFacultad
     */
    public function getFacultad()
    {
        return $this->facultad;
    }

    /**
     * Set the value of facultad
     *
     * @param  \TFacultad  $facultad
     *
     * @return  self
     */
    public function setFacultad($facultad)
    {
        $this->facultad = $facultad;

        return $this;
    }

    /**
     * Get the value of modalidad
     *
     * @return  \TModalidad
     */
    public function getModalidad()
    {
        return $this->modalidad;
    }

    /**
     * Set the value of modalidad
     *
     * @param  \TModalidad  $modalidad
     *
     * @return  self
     */
    public function setModalidad($modalidad)
    {
        $this->modalidad = $modalidad;

        return $this;
    }

    /**
     * Get the value of plan
     *
     * @return  \TPlan
     */
    public function getPlan()
    {
        return $this->plan;
    }

    /**
     * Set the value of plan
     *
     * @param  \TPlan  $plan
     *
     * @return  self
     */
    public function setPlan($plan)
    {
        $this->plan = $plan;

        return $this;
    }

    /**
     * Get the value of titulo
     *
     * @return  \TTitulacionMaestro
     */
    public function getTitulo()
    {
        return $this->titulo;
    }

    /**
     * Set the value of titulo
     *
     * @param  \TTitulacionMaestro  $titulo
     *
     * @return  self
     */
    public function setTitulo($titulo)
    {
        $this->titulo = $titulo;

        return $this;
    }
}
