<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Security\Core\User\UserInterface;

/**
 * Tusuarios
 *
 * @ORM\Table(name="usuarios_t", schema="unam_ga")
 * @ORM\Entity
 */
class Tusuarios
{
    const K_ENTIDAD = 'App\Entity\Tusuarios';
    const ROLTXT = [1 => 'GA.ADMIN', 2 => 'GA.COORDINADOR', 3 =>  'GA.LECTURA'];
    const ROL = ['3' => "Lectura", '2' => 'Coordinador', '1' => 'Administrador'];

    const TIPO = ['4' => "Coordinador", '3' => 'Decanato', '2' => 'Calidad', '1' => 'Rectorado'];

    const K_TIPO_COORDINADOR = 4;
    const K_TIPO_DECANO = 3;
    const K_TIPO_CALIDAD = 2;
    const K_TIPO_RECTOR = 1;

    /**
     * @var int
     *
     * @ORM\Column(name="id", type="bigint", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="nombre", type="string", length=255, nullable=false)
     */
    private $nombre;

    /**
     * @var string|null
     *
     * @ORM\Column(name="email", type="string", length=255, nullable=true)
     */
    private $email;

    /**
     * @var integer|null
     *
     * @ORM\Column(name="rol_id", type="integer", nullable=true)
     */
    private $rol;

    /**
     * @var integer|null
     *
     * @ORM\Column(name="tipo", type="integer", nullable=true)
     */
    private $tipo;

    /**
     * @var string|null
     *
     * @ORM\Column(name="telefono", type="string", length=255, nullable=true)
     */
    private $tlf;

    private $roles = [];


    /**
     * @var \TFacultad
     *
     * @ORM\ManyToOne(targetEntity="TFacultad")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="facultad_id", referencedColumnName="id")
     * })
     */
    private $facultad;

    /**
     * Get the value of id
     *
     * @return  int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set the value of id
     *
     * @param  int  $id
     *
     * @return  self
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * Get the value of nombre
     *
     * @return  string
     */
    public function getNombre()
    {
        return $this->nombre;
    }

    /**
     * Set the value of nombre
     *
     * @param  string  $nombre
     *
     * @return  self
     */
    public function setNombre($nombre)
    {
        $this->nombre = $nombre;

        return $this;
    }

    /**
     * Get the value of email
     *
     * @return  string|null
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Set the value of email
     *
     * @param  string|null  $email
     *
     * @return  self
     */
    public function setEmail($email)
    {
        $this->email = $email;

        return $this;
    }

    /**
     * Get the value of rol
     *
     * @return  integer|null
     */
    public function getRol()
    {
        return $this->rol;
    }

    /**
     * Set the value of rol
     *
     * @param  integer|null  $rol
     *
     * @return  self
     */
    public function setRol($rol)
    {
        $this->rol = $rol;

        return $this;
    }


    /**
     * Get the value of roles
     */
    public function getRoles()
    {
        return $this->roles;
    }

    /**
     * Set the value of roles
     *
     * @return  self
     */
    public function setRoles($roles)
    {
        $this->roles = $roles;

        return $this;
    }

    /**
     * Get the value of facultad
     *
     * @return  \TFacultad
     */
    public function getFacultad()
    {
        return $this->facultad;
    }

    /**
     * Set the value of facultad
     *
     * @param  \TFacultad  $facultad
     *
     * @return  self
     */
    public function setFacultad($facultad)
    {
        $this->facultad = $facultad;

        return $this;
    }

    /**
     * Get the value of tipo
     *
     * @return  integer|null
     */
    public function getTipo()
    {
        return $this->tipo;
    }

    /**
     * Set the value of tipo
     *
     * @param  integer|null  $tipo
     *
     * @return  self
     */
    public function setTipo($tipo)
    {
        $this->tipo = $tipo;

        return $this;
    }

    /**
     * Get the value of tlf
     *
     * @return  string|null
     */ 
    public function getTlf()
    {
        return $this->tlf;
    }

    /**
     * Set the value of tlf
     *
     * @param  string|null  $tlf
     *
     * @return  self
     */ 
    public function setTlf($tlf)
    {
        $this->tlf = $tlf;

        return $this;
    }
}
