<?php

namespace Microsoft\Graph\Generated\Admin\Microsoft365Apps\InstallationOptions;

use Microsoft\Kiota\Abstractions\QueryParameter;

/**
 * A container for tenant-level settings for Microsoft 365 applications.
*/
class InstallationOptionsRequestBuilderGetQueryParameters 
{
    /**
     * @QueryParameter("%24expand")
     * @var array<string>|null $expand Expand related entities
    */
    public ?array $expand = null;
    
    /**
     * @QueryParameter("%24select")
     * @var array<string>|null $select Select properties to be returned
    */
    public ?array $select = null;
    
    /**
     * Instantiates a new InstallationOptionsRequestBuilderGetQueryParameters and sets the default values.
     * @param array<string>|null $expand Expand related entities
     * @param array<string>|null $select Select properties to be returned
    */
    public function __construct(?array $expand = null, ?array $select = null) {
        $this->expand = $expand;
        $this->select = $select;
    }

}
