<?php

namespace Microsoft\Graph\Generated\Admin\People\ProfileCardProperties\Item;

use Microsoft\Kiota\Abstractions\QueryParameter;

/**
 * Contains a collection of the properties an administrator has defined as visible on the Microsoft 365 profile card.
*/
class ProfileCardPropertyItemRequestBuilderGetQueryParameters 
{
    /**
     * @QueryParameter("%24expand")
     * @var array<string>|null $expand Expand related entities
    */
    public ?array $expand = null;
    
    /**
     * @QueryParameter("%24select")
     * @var array<string>|null $select Select properties to be returned
    */
    public ?array $select = null;
    
    /**
     * Instantiates a new ProfileCardPropertyItemRequestBuilderGetQueryParameters and sets the default values.
     * @param array<string>|null $expand Expand related entities
     * @param array<string>|null $select Select properties to be returned
    */
    public function __construct(?array $expand = null, ?array $select = null) {
        $this->expand = $expand;
        $this->select = $select;
    }

}
