<?php

namespace Microsoft\Graph\Generated\Policies\AdminConsentRequestPolicy;

use Microsoft\Kiota\Abstractions\QueryParameter;

/**
 * The policy by which consent requests are created and managed for the entire tenant.
*/
class AdminConsentRequestPolicyRequestBuilderGetQueryParameters 
{
    /**
     * @QueryParameter("%24expand")
     * @var array<string>|null $expand Expand related entities
    */
    public ?array $expand = null;
    
    /**
     * @QueryParameter("%24select")
     * @var array<string>|null $select Select properties to be returned
    */
    public ?array $select = null;
    
    /**
     * Instantiates a new AdminConsentRequestPolicyRequestBuilderGetQueryParameters and sets the default values.
     * @param array<string>|null $expand Expand related entities
     * @param array<string>|null $select Select properties to be returned
    */
    public function __construct(?array $expand = null, ?array $select = null) {
        $this->expand = $expand;
        $this->select = $select;
    }

}
