<?php

namespace Microsoft\Graph\Generated\Policies\CrossTenantAccessPolicy;

use Microsoft\Kiota\Abstractions\QueryParameter;

/**
 * The custom rules that define an access scenario when interacting with external Microsoft Entra tenants.
*/
class CrossTenantAccessPolicyRequestBuilderGetQueryParameters 
{
    /**
     * @QueryParameter("%24expand")
     * @var array<string>|null $expand Expand related entities
    */
    public ?array $expand = null;
    
    /**
     * @QueryParameter("%24select")
     * @var array<string>|null $select Select properties to be returned
    */
    public ?array $select = null;
    
    /**
     * Instantiates a new CrossTenantAccessPolicyRequestBuilderGetQueryParameters and sets the default values.
     * @param array<string>|null $expand Expand related entities
     * @param array<string>|null $select Select properties to be returned
    */
    public function __construct(?array $expand = null, ?array $select = null) {
        $this->expand = $expand;
        $this->select = $select;
    }

}
