<?php

namespace Microsoft\Graph\Generated\Security\ThreatIntelligence\ArticleIndicators\Item;

use Microsoft\Kiota\Abstractions\QueryParameter;

/**
 * Refers to indicators of threat or compromise highlighted in an article.Note: List retrieval is not yet supported.
*/
class ArticleIndicatorItemRequestBuilderGetQueryParameters 
{
    /**
     * @QueryParameter("%24expand")
     * @var array<string>|null $expand Expand related entities
    */
    public ?array $expand = null;
    
    /**
     * @QueryParameter("%24select")
     * @var array<string>|null $select Select properties to be returned
    */
    public ?array $select = null;
    
    /**
     * Instantiates a new ArticleIndicatorItemRequestBuilderGetQueryParameters and sets the default values.
     * @param array<string>|null $expand Expand related entities
     * @param array<string>|null $select Select properties to be returned
    */
    public function __construct(?array $expand = null, ?array $select = null) {
        $this->expand = $expand;
        $this->select = $select;
    }

}
